Index: trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AHDh_HReset.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AHDh_HReset.asm	(revision 149)
+++ trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AHDh_HReset.asm	(revision 150)
@@ -12,6 +12,6 @@
 ;		DL:		Translated Drive number
 ;		DS:DI:	Ptr to DPT (in RAMVARS segment)
-;		SS:BP:	Ptr to INTPACK
-;	Returns with INTPACK in SS:BP:
+;		SS:BP:	Ptr to IDEPACK
+;	Returns with INTPACK:
 ;		AH:		Int 13h return status
 ;		CF:		0 if succesfull, 1 if error
@@ -35,9 +35,10 @@
 ;		DL:		Drive number
 ;		DS:		RAMVARS segment
+;		SS:BP:	Ptr to IDEPACK
 ;	Returns:
 ;		AH:		Int 13h return status
 ;		CF:		0 if succesfull, 1 if error
 ;	Corrupts registers:
-;		AL, CX, DI
+;		AL, CX, SI, DI
 ;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
@@ -48,11 +49,12 @@
 	call	FindDPT_ForDriveNumber		; DS:DI now points to DPT
 	call	Interrupts_UnmaskInterruptControllerForDriveInDSDI
-	call	AHDh_ResetMasterAndSlave
+	call	Device_ResetMasterAndSlaveController
 	;jc		SHORT .ReturnError			; CF would be set if slave drive present without master
 										; (error register has special values after reset)
 
 	; Initialize Master and Slave drives
-	mov		dx, [RAMVARS.wIdeBase]		; Load base port address
-	call	AHDh_InitializeMasterAndSlave
+	eMOVZX	bx, BYTE [di+DPT.bIdevarsOffset]
+	mov		dx, [cs:bx+IDEVARS.wPort]
+	call	InitializeMasterAndSlaveDriveFromPortInDX
 
 	pop		bx
@@ -62,44 +64,8 @@
 
 ;--------------------------------------------------------------------
-; Resets Master and Slave drives at wanted port.
-; Both IDE drives will be reset. It is not possible to reset
-; Master or Slave only.
-;
-; AHDh_ResetMasterAndSlave
-;	Parameters:
-;		DS:DI:	Ptr to DPT for Master or Slave drive
-;	Returns:
-;		CF:		0 if reset succesfull
-;				1 if any error
-;	Corrupts registers:
-;		AX, BX, CX, DX
-;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
-AHDh_ResetMasterAndSlave:
-	; Reset controller
-	; HSR0: Set_SRST
-	mov		al, [di+DPT.bDrvCtrl]		; Load value for ACR
-	or		al, FLG_IDE_CTRL_SRST		; Set Reset bit
-	call	HDrvSel_OutputDeviceControlByte
-	mov		ax, 5						; Delay at least 5us
-	call	HTimer_DelayMicrosecondsFromAX
-
-	; HSR1: Clear_wait
-	mov		al, [di+DPT.bDrvCtrl]		; Load value for ACR
-	out		dx, al						; End Reset
-	mov		ax, 2000					; Delay at least 2ms
-	call	HTimer_DelayMicrosecondsFromAX
-
-	; HSR2: Check_status
-	mov		cl, B_TIMEOUT_RESET			; Reset timeout delay
-	jmp		HStatus_WaitBsy
-
-
-;--------------------------------------------------------------------
-; Initializes Master and Slave drive.
-;
-; AHDh_InitializeMasterAndSlave
+; InitializeMasterAndSlaveDriveFromPortInDX
 ;	Parameters:
 ;		DX:		IDE Base Port address
+;		SS:BP:	Ptr to IDEPACK
 ;	Returns:
 ;		AH:		Error code
@@ -107,11 +73,11 @@
 ;				1 if any error
 ;	Corrupts registers:
-;		AL, BX, CX, DX, DI
+;		AL, BX, CX, DX, SI, DI
 ;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
-AHDh_InitializeMasterAndSlave:
+InitializeMasterAndSlaveDriveFromPortInDX:
 	push	dx							; Store base port address
 	xor		cx, cx						; Assume no errors
-	call	FindDPT_ForIdeMasterAtPort
+	call	FindDPT_ToDSDIForIdeMasterAtPortDX
 	jnc		SHORT .InitializeSlave		; Master drive not present
 	call	AH9h_InitializeDriveForUse
@@ -119,5 +85,5 @@
 .InitializeSlave:
 	pop		dx							; Restore base port address
-	call	FindDPT_ForIdeSlaveAtPort
+	call	FindDPT_ToDSDIForIdeSlaveAtPortDX
 	jnc		SHORT .CombineErrors		; Slave drive not present
 	call	AH9h_InitializeDriveForUse
Index: trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/Common/HAddress.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/Common/HAddress.asm	(revision 149)
+++ trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/Common/HAddress.asm	(revision 150)
@@ -1,7 +1,3 @@
-; File name		:	HAddress.asm
-; Project name	:	IDE BIOS
-; Created date	:	11.3.2010
-; Last update	:	4.4.2010
-; Author		:	Tomi Tilli
+; Project name	:	XTIDE Universal BIOS
 ; Description	:	Functions for address translations.
 
@@ -9,9 +5,15 @@
 SECTION .text
 
+; Jump table for conversion functions
+ALIGN WORD_ALIGN
+g_rgfnAddressTranslation:
+	dw		DoNotConvertLCHS					; 0, ADDR_DPT_LCHS
+	dw		ConvertLCHStoPCHS					; 1, ADDR_DPT_PCHS
+	dw		ConvertLCHStoLBARegisterValues		; 2, ADDR_DPT_LBA28
+	dw		ConvertLCHStoLBARegisterValues		; 3, ADDR_DPT_LBA48
+
+
 ;--------------------------------------------------------------------
-; Outputs sector count, L-CHS address and command to IDE registers.
-; This function does not wait until command has been completed.
-;
-; HAddress_ConvertParamsFromBiosLCHStoIDE
+; HAddress_OldInt13hAddressToIdeAddress
 ;	Parameters:
 ;		CH:		Cylinder number, bits 7...0
@@ -28,22 +30,12 @@
 ;		AX, DX
 ;--------------------------------------------------------------------
-ALIGN WORD_ALIGN
-g_rgfnAddressTranslation:
-	dw		HAddress_DoNotConvertLCHS					; 0, ADDR_DPT_LCHS
-	dw		HAddress_ConvertLCHStoPCHS					; 1, ADDR_DPT_PCHS
-	dw		HAddress_ConvertLCHStoLBARegisterValues		; 2, ADDR_DPT_LBA28
-	dw		HAddress_ConvertLCHStoLBARegisterValues		; 3, ADDR_DPT_LBA48
-
 ALIGN JUMP_ALIGN
-HAddress_ConvertParamsFromBiosLCHStoIDE:
-	mov		bl, [di+DPT.bFlags]
-	and		bx, BYTE MASK_DPT_ADDR						; Addressing mode to BX
+HAddress_OldInt13hAddressToIdeAddress:
+	call	AccessDPT_GetAddressingModeForWordLookToBX
 	push	WORD [cs:bx+g_rgfnAddressTranslation]		; Push return address
-	; Fall to HAddress_ExtractLCHSFromBiosParams
+	; Fall to HAddress_ExtractLCHSparametersFromOldInt13hAddress
 
 ;---------------------------------------------------------------------
-; Extracts L-CHS parameters from BIOS function parameters.
-;
-; HAddress_ExtractLCHSFromBiosParams:
+; HAddress_ExtractLCHSparametersFromOldInt13hAddress
 ;	Parameters:
 ;		CH:		Cylinder number, bits 7...0
@@ -58,6 +50,5 @@
 ;		Nothing
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
-HAddress_ExtractLCHSFromBiosParams:
+HAddress_ExtractLCHSparametersFromOldInt13hAddress:
 	mov		bl, cl				; Copy sector number...
 	and		bl, 3Fh				; ...and limit to 1...63
@@ -70,5 +61,5 @@
 
 ;---------------------------------------------------------------------
-; Converts BIOS LCHS parameters to IDE P-CHS parameters.
+; Converts LCHS parameters to IDE P-CHS parameters.
 ; PCylinder	= (LCylinder << n) + (LHead / PHeadCount)
 ; PHead		= LHead % PHeadCount
@@ -89,8 +80,8 @@
 ;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
-HAddress_ConvertLCHStoPCHS:
+ConvertLCHStoPCHS:
 	; LHead / PHeadCount and LHead % PHeadCount
 	eMOVZX	ax, bh					; Copy L-CHS Head number to AX
-	div		BYTE [di+DPT.bPHeads]	; AL = LHead / PHeadCount, AH = LHead % PHeadCount
+	div		BYTE [di+DPT.bPchsHeads]; AL = LHead / PHeadCount, AH = LHead % PHeadCount
 	mov		bh, ah					; Copy P-CHS Head number to BH
 	xor		ah, ah					; AX = LHead / PHeadCount
@@ -98,10 +89,10 @@
 	; (LCylinder << n) + (LHead / PHeadCount)
 	mov		dx, cx					; Copy L-CHS Cylinder number to DX
-	mov		cl, [di+DPT.bShLtoP]	; Load shift count
+	mov		cl, [di+DPT.wFlags]		; Load shift count
+	and		cl, MASK_DPT_CHS_SHIFT_COUNT
 	shl		dx, cl					; DX = LCylinder << n
 	add		ax, dx					; AX = P-CHS Cylinder number
 	mov		cx, ax					; Copy P-CHS Cylinder number to CX
-ALIGN JUMP_ALIGN
-HAddress_DoNotConvertLCHS:
+DoNotConvertLCHS:
 	ret
 
@@ -109,8 +100,11 @@
 ;---------------------------------------------------------------------
 ; Converts LCHS parameters to 28-bit LBA address.
+; Only 24-bits are used since LHCS to LBA28 conversion has 8.4GB limit.
+; LBA = ((cylToSeek*headsPerCyl+headToSeek)*sectPerTrack)+sectToSeek-1
+;
 ; Returned address is in same registers that
 ; HAddress_DoNotConvertLCHS and HAddress_ConvertLCHStoPCHS returns.
 ;
-; HAddress_ConvertLCHStoLBARegisterValues:
+; ConvertLCHStoLBARegisterValues:
 ;	Parameters:
 ;		BL:		Sector number (1...63)
@@ -127,33 +121,9 @@
 ;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
-HAddress_ConvertLCHStoLBARegisterValues:
-	call	HAddress_ConvertLCHStoLBA28
-	mov		bl, al					; Sector Number Register (LBA 7...0)
-	mov		cl, ah					; Low Cylinder Register (LBA 15...8)
-	mov		ch, dl					; High Cylinder Register (LBA 23...16)
-	mov		bh, dh					; Drive and Head Register (LBA 27...24)
-	ret
-
-;---------------------------------------------------------------------
-; Converts LCHS parameters to 28-bit LBA address.
-; Only 24-bits are used since LHCS to LBA28 conversion has 8.4GB limit.
-; LBA = ((cylToSeek*headsPerCyl+headToSeek)*sectPerTrack)+sectToSeek-1
-;
-; HAddress_ConvertLCHStoLBA28:
-;	Parameters:
-;		BL:		Sector number (1...63)
-;		BH:		Head number (0...255)
-;		CX:		Cylinder number (0...1023)
-;		DS:DI:	Ptr to Disk Parameter Table
-;	Returns:
-;		DX:AX:	28-bit LBA address (DH is always zero)
-;	Corrupts registers:
-;		BX, CX
-;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
-HAddress_ConvertLCHStoLBA28:
+ConvertLCHStoLBARegisterValues:
 	; cylToSeek*headsPerCyl (18-bit result)
 	mov		ax, cx					; Copy Cylinder number to AX
-	mul		WORD [di+DPT.wLHeads]	; DX:AX = cylToSeek*headsPerCyl
+	eMOVZX	dx, BYTE [di+DPT.bLchsHeads]
+	mul		dx						; DX:AX = cylToSeek*headsPerCyl
 
 	; +=headToSeek (18-bit result)
@@ -163,5 +133,5 @@
 
 	; *=sectPerTrack (18-bit by 6-bit multiplication with 24-bit result)
-	eMOVZX	cx, BYTE [di+DPT.bPSect]; Load Sectors per Track
+	eMOVZX	cx, BYTE [di+DPT.bPchsSectors]	; Load Sectors per Track
 	xchg	ax, dx					; Hiword to AX, loword to DX
 	mul		cl						; AX = hiword * Sectors per Track
@@ -176,3 +146,9 @@
 	add		ax, bx					; Add to loword
 	adc		dl, bh					; Add possible carry to byte2, BH=zero
+
+	; Copy DX:AX to proper return registers
+	xchg	bx, ax					; BL = Sector Number Register (LBA 7...0)
+	mov		cl, bh					; Low Cylinder Register (LBA 15...8)
+	mov		ch, dl					; High Cylinder Register (LBA 23...16)
+	mov		bh, dh					; Drive and Head Register (LBA 27...24)
 	ret
Index: trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/Common/HTimer.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/Common/HTimer.asm	(revision 149)
+++ trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/Common/HTimer.asm	(revision 150)
@@ -6,7 +6,7 @@
 
 ;--------------------------------------------------------------------
-; HTimer_InitializeTimeoutWithTicksInCL
+; HTimer_InitializeTimeoutWithTicksInCX
 ;	Parameters:
-;		CL:		Timeout value in system timer ticks
+;		CX:		Timeout value in system timer ticks
 ;		DS:		Segment to RAMVARS
 ;	Returns:
@@ -16,6 +16,5 @@
 ;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
-HTimer_InitializeTimeoutWithTicksInCL:
-	xor		ch, ch							; Timeout ticks now in CX
+HTimer_InitializeTimeoutWithTicksInCX:
 	mov		[RAMVARS.wTimeoutCounter], cx	; Store timeout ticks
 	call	ReadTimeFromBdaToCX
@@ -55,5 +54,5 @@
 HTimer_DelayMicrosecondsFromAX:
 %ifndef USE_AT
-	mov		ax, 1
+	mov		ax, 2
 	; Fall to Delay_TimerTicksFromAX
 %else
Index: trunk/XTIDE_Universal_BIOS/Src/Initialization/DetectDrives.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Initialization/DetectDrives.asm	(revision 149)
+++ trunk/XTIDE_Universal_BIOS/Src/Initialization/DetectDrives.asm	(revision 150)
@@ -1,3 +1,3 @@
-; Project name	:	IDE BIOS
+; Project name	:	XTIDE Universal BIOS
 ; Description	:	Functions for detecting drive for the BIOS.
 
@@ -43,9 +43,9 @@
 	push	cx
 	mov		ax, g_szMaster
-	mov		bh, MASK_IDE_DRVHD_SET								; Select Master drive
+	mov		bh, MASK_DRVNHEAD_SET								; Select Master drive
 	call	StartDetectionWithDriveSelectByteInBHandStringInAX	; Detect and create DPT + BOOTNFO
 
 	mov		ax, g_szSlave
-	mov		bh, MASK_IDE_DRVHD_SET | FLG_IDE_DRVHD_DRV
+	mov		bh, MASK_DRVNHEAD_SET | FLG_DRVNHEAD_DRV
 	call	StartDetectionWithDriveSelectByteInBHandStringInAX
 	pop		cx
@@ -78,15 +78,18 @@
 ;		ES:		Zero (BDA segment)
 ;	Returns:
-;		ES:SI	Ptr to ATA information (read with IDENTIFY DEVICE command)
 ;		CF:		Cleared if ATA-information read successfully
 ;				Set if any error
 ;	Corrupts registers:
-;		AX, BL, CX, DX, DI
+;		AX, BL, CX, DX, SI, DI
 ;--------------------------------------------------------------------
 .ReadAtaInfoFromHardDisk:
-	mov		bl, [cs:bp+IDEVARS.bBusType]; Load BUS type
-	mov		dx, [cs:bp+IDEVARS.wPort]	; Load IDE Base Port address
-	mov		di, BOOTVARS.rgbAtaInfo		; ES:DI now points to ATA info location
-	call	AH25h_GetDriveInfo
+	mov		si, BOOTVARS.rgbAtaInfo		; ES:SI now points to ATA info location
+	push	es
+	push	si
+	push	bx
+	call	Device_IdentifyToBufferInESSIwithDriveSelectByteInBH
+	pop		bx
+	pop		si
+	pop		es
 	jnc		SHORT CreateBiosTablesForHardDisk
 	; Fall to .ReadAtapiInfoFromDrive
@@ -103,5 +106,5 @@
 ;		BH:		Drive Select byte for Drive and Head Register
 ;		CS:BP:	Ptr to IDEVARS for the drive
-;		ES:DI	Ptr to ATA information for the drive
+;		ES:SI	Ptr to ATA information for the drive
 ;		DS:		RAMVARS segment
 ;		ES:		BDA/Bootnfo segment
@@ -112,5 +115,4 @@
 ;--------------------------------------------------------------------
 CreateBiosTablesForHardDisk:
-	mov		si, di					; ES:SI now points to ATA information
 	call	CreateDPT_FromAtaInformation
 	jc		SHORT .InvalidAtaInfo
Index: trunk/XTIDE_Universal_BIOS/Src/Initialization/Initialize.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Initialization/Initialize.asm	(revision 149)
+++ trunk/XTIDE_Universal_BIOS/Src/Initialization/Initialize.asm	(revision 150)
@@ -108,6 +108,9 @@
 ;		Nothing
 ;	Corrupts registers:
-;		AX, BX, CX, DX, DI
+;		All
 ;--------------------------------------------------------------------
 .ResetDetectedDrives:
-	jmp		AH0h_ResetHardDisksHandledByOurBIOS
+	call	Idepack_FakeToSSBP
+	call	AH0h_ResetHardDisksHandledByOurBIOS
+	add		sp, BYTE SIZE_OF_FAKE_IDEPACK
+	ret
Index: trunk/XTIDE_Universal_BIOS/Src/Initialization/Interrupts.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Initialization/Interrupts.asm	(revision 149)
+++ trunk/XTIDE_Universal_BIOS/Src/Initialization/Interrupts.asm	(revision 150)
@@ -111,5 +111,5 @@
 .InstallHighIrqHandler:
 	add		bx, BYTE INTV_IRQ8 - 8			; Interrupt vector number
-	mov		si, HIRQ_InterruptServiceRoutineForIrqs8to15
+	mov		si, IdeIrq_InterruptServiceRoutineForIrqs8to15
 	jmp		SHORT Interrupts_InstallHandlerToVectorInBXFromCSSI
 
@@ -126,5 +126,5 @@
 .InstallLowIrqHandler:
 	add		bx, BYTE INTV_IRQ0				; Interrupt vector number
-	mov		si, HIRQ_InterruptServiceRoutineForIrqs2to7
+	mov		si, IdeIrq_InterruptServiceRoutineForIrqs2to7
 	; Fall to Interrupts_InstallHandlerToVectorInBXFromCSSI
 
@@ -158,5 +158,5 @@
 ;--------------------------------------------------------------------
 Interrupts_UnmaskInterruptControllerForDriveInDSDI:
-	eMOVZX	bx, BYTE [di+DPT.bIdeOff]
+	eMOVZX	bx, BYTE [di+DPT.bIdevarsOffset]
 	mov		al, [cs:bx+IDEVARS.bIRQ]
 	test	al, al
Index: trunk/XTIDE_Universal_BIOS/Src/Main.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Main.asm	(revision 149)
+++ trunk/XTIDE_Universal_BIOS/Src/Main.asm	(revision 150)
@@ -25,4 +25,5 @@
 %include "BootMenu.inc"			; For Boot Menu
 %include "IDE_8bit.inc"			; For IDE 8-bit data port macros
+%include "DeviceIDE.inc"		; For IDE device equates
 
 
@@ -55,5 +56,5 @@
 	at	ROMVARS.wDisplayMode,	dw	DEFAULT_TEXT_MODE
 	at	ROMVARS.wBootTimeout,	dw	30 * TICKS_PER_SECOND	; Boot Menu selection timeout
-	at	ROMVARS.bIdeCnt,		db	3						; Number of supported controllers
+	at	ROMVARS.bIdeCnt,		db	4						; Number of supported controllers
 	at	ROMVARS.bBootDrv,		db	80h						; Boot Menu default drive
 	at	ROMVARS.bMinFddCnt, 	db	0						; Do not force minimum number of floppy drives
@@ -62,6 +63,6 @@
 	at	ROMVARS.ideVars0+IDEVARS.wPort,			dw	1F0h			; Controller Command Block base port
 	at	ROMVARS.ideVars0+IDEVARS.wPortCtrl,		dw	3F0h			; Controller Control Block base port
-	at	ROMVARS.ideVars0+IDEVARS.bBusType,		db	BUS_TYPE_16		; Bus type
-	at	ROMVARS.ideVars0+IDEVARS.bIRQ,			db	14				; IRQ
+	at	ROMVARS.ideVars0+IDEVARS.bDevice,		db	DEVICE_16BIT_ATA
+	at	ROMVARS.ideVars0+IDEVARS.bIRQ,			db	14
 	at	ROMVARS.ideVars0+IDEVARS.drvParamsMaster+DRVPARAMS.wFlags,	db	FLG_DRVPARAMS_BLOCKMODE
 	at	ROMVARS.ideVars0+IDEVARS.drvParamsSlave+DRVPARAMS.wFlags,	db	FLG_DRVPARAMS_BLOCKMODE
@@ -69,6 +70,6 @@
 	at	ROMVARS.ideVars1+IDEVARS.wPort,			dw	170h			; Controller Command Block base port
 	at	ROMVARS.ideVars1+IDEVARS.wPortCtrl,		dw	370h			; Controller Control Block base port
-	at	ROMVARS.ideVars1+IDEVARS.bBusType,		db	BUS_TYPE_16		; Bus type
-	at	ROMVARS.ideVars1+IDEVARS.bIRQ,			db	15				; IRQ
+	at	ROMVARS.ideVars1+IDEVARS.bDevice,		db	DEVICE_16BIT_ATA
+	at	ROMVARS.ideVars1+IDEVARS.bIRQ,			db	15
 	at	ROMVARS.ideVars1+IDEVARS.drvParamsMaster+DRVPARAMS.wFlags,	db	FLG_DRVPARAMS_BLOCKMODE
 	at	ROMVARS.ideVars1+IDEVARS.drvParamsSlave+DRVPARAMS.wFlags,	db	FLG_DRVPARAMS_BLOCKMODE
@@ -76,6 +77,6 @@
 	at	ROMVARS.ideVars2+IDEVARS.wPort,			dw	300h			; Controller Command Block base port
 	at	ROMVARS.ideVars2+IDEVARS.wPortCtrl,		dw	308h			; Controller Control Block base port
-	at	ROMVARS.ideVars2+IDEVARS.bBusType,		db	BUS_TYPE_8_DUAL	; Bus type
-	at	ROMVARS.ideVars2+IDEVARS.bIRQ,			db	0				; IRQ
+	at	ROMVARS.ideVars2+IDEVARS.bDevice,		db	DEVICE_8BIT_DUAL_PORT_XTIDE
+	at	ROMVARS.ideVars2+IDEVARS.bIRQ,			db	0
 	at	ROMVARS.ideVars2+IDEVARS.drvParamsMaster+DRVPARAMS.wFlags,	db	FLG_DRVPARAMS_BLOCKMODE
 	at	ROMVARS.ideVars2+IDEVARS.drvParamsSlave+DRVPARAMS.wFlags,	db	FLG_DRVPARAMS_BLOCKMODE
@@ -83,6 +84,6 @@
 	at	ROMVARS.ideVars3+IDEVARS.wPort,			dw	168h			; Controller Command Block base port
 	at	ROMVARS.ideVars3+IDEVARS.wPortCtrl,		dw	368h			; Controller Control Block base port
-	at	ROMVARS.ideVars3+IDEVARS.bBusType,		db	BUS_TYPE_16		; Bus type
-	at	ROMVARS.ideVars3+IDEVARS.bIRQ,			db	0				; IRQ
+	at	ROMVARS.ideVars3+IDEVARS.bDevice,		db	DEVICE_16BIT_ATA
+	at	ROMVARS.ideVars3+IDEVARS.bIRQ,			db	0
 	at	ROMVARS.ideVars3+IDEVARS.drvParamsMaster+DRVPARAMS.wFlags,	db	FLG_DRVPARAMS_BLOCKMODE
 	at	ROMVARS.ideVars3+IDEVARS.drvParamsSlave+DRVPARAMS.wFlags,	db	FLG_DRVPARAMS_BLOCKMODE
@@ -101,5 +102,5 @@
 	at	ROMVARS.ideVars0+IDEVARS.wPort,			dw	300h			; Controller Command Block base port
 	at	ROMVARS.ideVars0+IDEVARS.wPortCtrl,		dw	308h			; Controller Control Block base port
-	at	ROMVARS.ideVars0+IDEVARS.bBusType,		db	BUS_TYPE_8_DUAL	; Bus type
+	at	ROMVARS.ideVars0+IDEVARS.bDevice,		db	DEVICE_8BIT_DUAL_PORT_XTIDE
 	at	ROMVARS.ideVars0+IDEVARS.bIRQ,			db	0				; IRQ
 	at	ROMVARS.ideVars0+IDEVARS.drvParamsMaster+DRVPARAMS.wFlags,	db	FLG_DRVPARAMS_BLOCKMODE
@@ -146,11 +147,4 @@
 %include "DriveXlate.asm"		; For swapping drive numbers
 %include "HAddress.asm"			; For sector address translations
-%include "HCapacity.asm"		; For calculating drive capacity
-%include "HError.asm"			; For error checking
-%include "HPIO.asm"				; For PIO transfers
-%include "HIRQ.asm"				; For IRQ handling
-%include "HStatus.asm"			; For reading hard disk status
-%include "HDrvSel.asm"			; For selecting drive to access
-%include "HCommand.asm"			; For outputting command and parameters
 %include "HTimer.asm"			; For timeout and delay
 
@@ -178,5 +172,19 @@
 %include "AH24h_HSetBlocks.asm"	; Required by Int13h_Jump.asm
 %include "AH25h_HDrvID.asm"		; Required by Int13h_Jump.asm
+%include "Device.asm"
+%include "Idepack.asm"
 
+; IDE Device support
+%include "IdeCommand.asm"
+%include "IdeDPT.asm"
+%include "IdeIO.asm"
+%include "IdeIrq.asm"
+%include "IdeTransfer.asm"
+%include "IdeWait.asm"
+%include "IdeError.asm"			; Must be included after IdeWait.asm
+
+; Serial Port Device support
+%include "SerialCommand.asm"
+%include "SerialDPT.asm"
 
 
Index: trunk/XTIDE_Universal_BIOS/Src/VariablesAndDPTs/AccessDPT.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/VariablesAndDPTs/AccessDPT.asm	(revision 149)
+++ trunk/XTIDE_Universal_BIOS/Src/VariablesAndDPTs/AccessDPT.asm	(revision 150)
@@ -6,6 +6,57 @@
 
 ;--------------------------------------------------------------------
-; Returns L-CHS values from DPT.
-;
+; AccessDPT_GetDriveSelectByteToAL
+;	Parameters:
+;		DS:DI:	Ptr to Disk Parameter Table
+;	Returns:
+;		AL:		Drive Select Byte
+;	Corrupts registers:
+;		Nothing
+;--------------------------------------------------------------------
+ALIGN JUMP_ALIGN
+AccessDPT_GetDriveSelectByteToAL:
+	mov		al, [di+DPT.wFlags]
+	and		al, FLG_DRVNHEAD_LBA | FLG_DRVNHEAD_DRV
+	or		al, MASK_DRVNHEAD_SET	; Bits set to 1 for old drives
+	ret
+
+
+;--------------------------------------------------------------------
+; AccessDPT_GetDeviceControlByteToAL
+;	Parameters:
+;		DS:DI:	Ptr to Disk Parameter Table
+;	Returns:
+;		AL:		Device Control Byte
+;	Corrupts registers:
+;		Nothing
+;--------------------------------------------------------------------
+ALIGN JUMP_ALIGN
+AccessDPT_GetDeviceControlByteToAL:
+	xor		al, al
+	test	BYTE [di+DPT.wFlags], FLG_DPT_ENABLE_IRQ
+	jnz		SHORT .EnableDeviceIrq
+	or		al, FLG_DEVCONTROL_nIEN	; Disable IRQ
+.EnableDeviceIrq:
+	ret
+
+
+;--------------------------------------------------------------------
+; AccessDPT_GetAddressingModeForWordLookToBX
+;	Parameters:
+;		DS:DI:	Ptr to Disk Parameter Table
+;	Returns:
+;		BX:		Addressing Mode (L-CHS, P-CHS, LBA28, LBA48) shifted for WORD lookup
+;	Corrupts registers:
+;		Nothing
+;--------------------------------------------------------------------
+ALIGN JUMP_ALIGN
+AccessDPT_GetAddressingModeForWordLookToBX:
+	mov		bl, [di+DPT.wFlags]
+	and		bx, BYTE MASK_DPT_ADDRESSING_MODE
+	eSHR_IM	bx, ADDRESSING_MODE_FIELD_POSITION-1
+	ret
+
+
+;--------------------------------------------------------------------
 ; AccessDPT_GetLCHSfromPCHS
 ;	Parameters:
@@ -21,16 +72,15 @@
 AccessDPT_GetLCHSfromPCHS:
 	xchg	ax, cx
-	mov		cl, [di+DPT.bShLtoP]		; Load shift count
-	mov		bx, [di+DPT.wPCyls]			; Load P-CHS cylinders
-	shr		bx, cl						; Shift to L-CHS cylinders
+	mov		cl, [di+DPT.wFlags]
+	and		cl, MASK_DPT_CHS_SHIFT_COUNT	; Load shift count
+	mov		bx, [di+DPT.wPchsCylinders]		; Load P-CHS cylinders
+	shr		bx, cl							; Shift to L-CHS cylinders
 	xchg	cx, ax
-	mov		dx, [di+DPT.wLHeads]		; Load L-CHS heads
-	eMOVZX	ax, BYTE [di+DPT.bPSect]	; Load Sectors per track
+	eMOVZX	dx, BYTE [di+DPT.bLchsHeads]	; Load L-CHS heads
+	eMOVZX	ax, BYTE [di+DPT.bPchsSectors]	; Load Sectors per track
 	ret
 
 
 ;--------------------------------------------------------------------
-; Tests IDEVARS flags for master or slave drive.
-;
 ; AccessDPT_TestIdeVarsFlagsForMasterOrSlaveDrive
 ;	Parameters:
@@ -63,11 +113,9 @@
 ALIGN JUMP_ALIGN
 AccessDPT_GetPointerToDRVPARAMStoCSBX:
-	eMOVZX	bx, [di+DPT.bIdeOff]		; CS:BX points to IDEVARS
-	test	BYTE [di+DPT.bDrvSel], FLG_IDE_DRVHD_DRV
-	jnz		SHORT .ReturnPointerToSlaveDRVPARAMS
-	add		bx, BYTE IDEVARS.drvParamsMaster
+	eMOVZX	bx, [di+DPT.bIdevarsOffset]			; CS:BX points to IDEVARS
+	add		bx, BYTE IDEVARS.drvParamsMaster	; CS:BX points to Master Drive DRVPARAMS
+	test	BYTE [di+DPT.wFlags], FLG_DPT_SLAVE
+	jz		SHORT .ReturnPointerToDRVPARAMS
+	add		bx, BYTE DRVPARAMS_size				; CS:BX points to Slave Drive DRVPARAMS
+.ReturnPointerToDRVPARAMS:
 	ret
-ALIGN JUMP_ALIGN
-.ReturnPointerToSlaveDRVPARAMS:
-	add		bx, BYTE IDEVARS.drvParamsSlave
-	ret
